package ADS;

import javax.swing.*;

public class AVLBaum implements SuchStruk {
  public AVLKnoten Wurzel;

  public AVLBaum() {  Wurzel=null; }

  private void liquid(AVLKnoten i) {
    if (i.lSohn!=null) liquid(i.lSohn);
    if (i.rSohn!=null) liquid(i.rSohn);
    i=null;
  }

  protected void finalize() throws Throwable {
    if (Wurzel!=null) liquid(Wurzel);
  }

  public Elementtyp getElement(AVLKnoten p) {
    if (p!=null) return p.Inhalt; else return null;
  }

  public void setElement(Elementtyp e, AVLKnoten p) {
    if (p!=null) p.Inhalt=e;
  }

  public AVLKnoten lAussen(AVLKnoten p) {
    AVLKnoten result=p;
    if (p!=null)
      while (p.lSohn!=null) { p=p.lSohn; result=p; }
    return result;
  }

  public AVLKnoten rAussen(AVLKnoten p) {
    AVLKnoten result=p;
    if (p!=null)
      while (p.rSohn!=null) { p=p.rSohn; result=p; }
    return result;
  }

  public AVLKnoten minSchlKn() {   return lAussen(Wurzel); }

  public AVLKnoten maxSchlKn() {    return rAussen(Wurzel); }

  public AVLKnoten nextSchl(AVLKnoten p) {
    if (p!=null)
      if (p.rSohn!=null) p=lAussen(p.rSohn);
      else {
        while ((p.Vater!=null) && (p==p.Vater.rSohn)) p=p.Vater;
        p=p.Vater;
      };
    return p;
  }

  public AVLKnoten prevSchl(AVLKnoten p) {
    if (p!=null)
      if (p.lSohn!=null) p=rAussen(p.lSohn);
      else {
        while ((p.Vater!=null) && (p==p.Vater.lSohn)) p=p.Vater;
        p=p.Vater;
      };
    return p;
  }

  public ObjInt suchKn(String S, AVLKnoten Start) {
    boolean   found=false; int i=-1;
    String    SKn=new String();
    AVLKnoten Kn=Start, Vater=Start;
    while ((!found) && (Kn!=null)) {
      SKn=Kn.getSchluessel();
      found=SKn.equals(S);
      Vater=Kn;
      if (found) i=0;
      else
        if (S.compareTo(SKn)<0) { Kn=Kn.lSohn; i=-1; }
        else { Kn=Kn.rSohn; i=1; }
    }
    return new ObjInt(Vater,i);
  }

  public Elementtyp suchen(String S) {
    ObjInt SuchKn=suchKn(S,Wurzel);
    if (SuchKn.Fortsetz==0) return ((Elementtyp)((AVLKnoten) SuchKn.Obj).Inhalt);
    else return null;
  }

  public ObjInt suchEinfgDopp(String S, AVLKnoten Start) {
    int i=-1; String    SKn=new String();
    AVLKnoten Kn=Start, Vater=Start;
    while (Kn!=null) {
      SKn=Kn.getSchluessel();
      Vater=Kn;
      if (S.compareTo(SKn)<0) { Kn=Kn.lSohn; i=-1; }
      else { Kn=Kn.rSohn; i=1; }
    }
    return new ObjInt(Vater,i);
  }

  public void Rotation(AVLKnoten p, int Rchtg) {
    AVLKnoten  q, B1,B2,B3;
    Elementtyp e;
    if (Rchtg==-1) {
      q=p.lSohn; B1=q.lSohn; B2=q.rSohn; B3=p.rSohn;
      p.lSohn=B1; p.rSohn=q; q.lSohn=B2; q.rSohn=B3;
    }
    else {
      q=p.rSohn; B1=q.rSohn; B2=q.lSohn; B3=p.lSohn;
      p.lSohn=q; p.rSohn=B1; q.lSohn=B3; q.rSohn=B2;
    }
    p.HDiff=Hoehe(p.rSohn)-Hoehe(p.lSohn);
    q.HDiff=Hoehe(q.rSohn)-Hoehe(q.lSohn);
    if (B1!=null) B1.Vater=p;
    if (B3!=null) B3.Vater=q;
    e=p.Inhalt; p.Inhalt=q.Inhalt; q.Inhalt=e;
  }

  public boolean einfuegen(Elementtyp e) {
    AVLKnoten v,sh,enk; int r;
    if (e!=null) {
      String S=e.getSchluessel();
      ObjInt SuchKn=suchKn(S,Wurzel);
      if (SuchKn.Fortsetz!=0) {
        v=(AVLKnoten) SuchKn.Obj;
        sh=new AVLKnoten(e,v);
        if (v==null) Wurzel=sh;
        else {
          r=SuchKn.Fortsetz;
          if (r==-1) v.lSohn=sh; else v.rSohn=sh;
          do {
            if (r==-1) v.HDiff--; else v.HDiff++;
            if ((v.HDiff==-2) || (v.HDiff==2)) {
              int RotRchtg=v.HDiff/2;
              if (sh!=null && sh.HDiff==-RotRchtg) {
                Rotation(sh,-RotRchtg); Rotation(v,RotRchtg);
              }
              else Rotation(v,RotRchtg);
            }
            sh=v; v=sh.Vater;
            if (v!=null)
              if (sh==v.lSohn) r=-1; else r=1;
          } while (!((v==null) || (sh.HDiff==0)));
        }
        return true;
      }
      else return false;
    }
    else return false;
  }

  public boolean einfuegenDopp(Elementtyp e) {
    AVLKnoten v,sh,enk; int r;
    if (e!=null) {
      String S=e.getSchluessel();
      ObjInt SuchKn=suchEinfgDopp(S,Wurzel);
      v=(AVLKnoten) SuchKn.Obj;
      sh=new AVLKnoten(e,v);
      if (v==null) Wurzel=sh;
      else {
        r=SuchKn.Fortsetz;
        if (r==-1) v.lSohn=sh; else v.rSohn=sh;
        do {
          if (r==-1) v.HDiff--; else v.HDiff++;
          if ((v.HDiff==-2) || (v.HDiff==2)) {
            int RotRchtg=v.HDiff/2;
            if (sh!=null && sh.HDiff==-RotRchtg) {
              Rotation(sh,-RotRchtg); Rotation(v,RotRchtg);
            }
            else Rotation(v,RotRchtg);
          }
          sh=v; v=sh.Vater;
          if (v!=null) if (sh==v.lSohn) r=-1; else r=1;
        } while (!((v==null) || (sh.HDiff==0)));
      }
      return true;
    }
    else return false;
  }

  public boolean entfernen(String S) {
    int  Rchtg;  boolean Abbr;
    AVLKnoten h,v,sh,enk;
    ObjInt   SuchKn=suchKn(S,Wurzel);

    if (SuchKn.Fortsetz!=0) return false;
    else {
      sh=(AVLKnoten) SuchKn.Obj;
      h=sh;
      if (h.rSohn!=null) { h=nextSchl(h);  sh.Inhalt=h.Inhalt; sh=h; }
      if (h.rSohn!=null) { h=nextSchl(h);  sh.Inhalt=h.Inhalt; sh=h; }
      if (h.lSohn!=null) { h=prevSchl(h);  sh.Inhalt=h.Inhalt; sh=h; }
      v=sh.Vater;
      if (v==null) Wurzel =null;
      else {
        if (sh==v.lSohn) { Rchtg=1; v.lSohn=null; }
        else { Rchtg=-1; v.rSohn=null; }
        do {
          Abbr=(v.HDiff==0);
          v.HDiff=v.HDiff+Rchtg;
          if ((v.HDiff==-2) || (v.HDiff==2)) {
            int RotRchtg=v.HDiff/2;
            if (RotRchtg==-1) sh=v.lSohn; else sh=v.rSohn;
            if (sh.HDiff==-RotRchtg) {
              Rotation(sh,-RotRchtg); Rotation(v,RotRchtg);
              Rchtg=-RotRchtg;
            }
            else { Abbr=sh.HDiff==0; Rotation(v,RotRchtg); Rchtg=-RotRchtg; }
          }
          sh=v; v=sh.Vater;
          if (v!=null && sh==v.lSohn) Rchtg=1; else Rchtg=-1;
        } while (v!=null && !Abbr);
      }
      return true;
    }
  }

  public int Hoehe(AVLKnoten k) {
  /** = Hoehe des in k wurzelnden Unterbaums */
    if (k==null) return 0;
    else {
      int hl=Hoehe(k.lSohn); int hr=Hoehe(k.rSohn);
      if (hr<hl) return 1+hl; else return 1+hr;
    }
  }

 public static int ZweiHoch(int exp) {
   int result=1;
   if (exp>0) result=result << exp;
   return result;
 }

  public int[] EtagOrd(String s, AVLKnoten start) {
  /** int[0]=Etagennummer, int[1]=Nummer innerhalb der Etage */
    AVLKnoten k=start;
    boolean   found=false;
    int etage=0; int ordInEtg=0;
    while (!found && (k!=null)) {
      found=k.getSchluessel().equals(s);
      if (! found) {
        etage++;
        if (s.compareTo(k.getSchluessel())<0) {
          k=k.lSohn; ordInEtg=2*ordInEtg;
        }
        else {
          k=k.rSohn; ordInEtg=2*ordInEtg+1;
        }
      }
    }
    if (found) return (new int[]{etage,ordInEtg});
    else return new int[]{-1,-1};
  }

 public void KnAusgabe(AVLKnoten i, JTable T,
                       int spalte, int zeile, int breite) {
   if (zeile<15) {
     T.setValueAt(               i.getSchluessel(),zeile,  spalte);
     T.setValueAt((new Integer(i.HDiff).toString()),zeile+1,spalte);
     breite=breite/2; int nSpalte=spalte+breite; zeile=zeile+3;
     if (i.lSohn!=null) KnAusgabe(i.lSohn,T, spalte,zeile,breite);
     if (i.rSohn!=null) KnAusgabe(i.rSohn,T,nSpalte,zeile,breite);
   }
 }

 public void BaumAusgabe(JTable T, AVLKnoten Kn) {
   int breite, H=Hoehe(Kn);
   if (H==0) breite=1; else breite=1<<(H-1);
   if (Kn==null) T.setValueAt("leer",0,0);
   else {
     for (int i=0; i<T.getRowCount(); i++)
       for (int j=0; j<T.getColumnCount(); j++)
         T.setValueAt("",i,j);
    KnAusgabe(Kn,T,0,0,breite);
   }
 }

  public class ObjInt {
    public Object Obj; public int Fortsetz;
    public ObjInt(Object o, int i) { Obj=o; Fortsetz=i;  }
  }
}