package ADS;

import javax.swing.*;

public class BBaum implements SuchStruk{
  private BBaumseite Wurzel;
  public int        m;

  public BBaum(int m) { this.m=m; Wurzel=null; }

  public BBaumseite getWurzel() { return Wurzel; }

  private void liquid(BBaumseite p) {
    for (int i=0; i<p.count(); i++) {
      BBaumseite q=((BBaumzeile) p.getElement(i)).Sohn;
      if (q!=null) liquid(q);
    }
    p=null;
  }

  protected void finalize() throws Throwable {
    if (Wurzel!=null) liquid(Wurzel);
  }

  public SeiteInt nextSchl(BBaumseite p, int i) {
    SeiteInt result;
    if ((p==null) || (i==0)) result=new SeiteInt(null,-1);
    else {
      BBaumseite Shn=((BBaumzeile) p.getElement(i)).Sohn;
      if (Shn==null)
        if (i<p.count()-1) result=new SeiteInt(p,i+1);
        else {
          BBaumseite Vtr=p.Vater;
          int Vz=p.Vaterzeile;
          while ((Vtr!=null) && (Vz==Vtr.count()-1)) {
            Vz=Vtr.Vaterzeile; Vtr=Vtr.Vater;
          }
          if (Vtr==null) result=new SeiteInt(null,-1);
          else result=new SeiteInt(Vtr,Vz+1);
        }
      else result=new SeiteInt(minSchlSeite(Shn),1);
    }
    return result;
  }

  public SeiteInt prevSchl(BBaumseite p, int i) {
    BBaumseite Shn,Vtr,hs;   SeiteInt result;
    if ((p==null) || (i==0)) result=new SeiteInt(null,-1);
    else {
      Shn=((BBaumzeile) p.getElement(i-1)).Sohn;
      if (Shn==null)
        if (i>1) result=new SeiteInt(p,i-1);
        else {
          Vtr=p.Vater;
          int Vz=p.Vaterzeile;
          while ((Vtr!=null) && (Vz==0)) { Vz=Vtr.Vaterzeile; Vtr=Vtr.Vater; }
          if (Vtr==null) result=new SeiteInt(null,-1);
          else result=new SeiteInt(Vtr,Vz);
        }
      else {
        hs=maxSchlSeite(Shn);
        return result=new SeiteInt(hs,hs.count()-1);
      }
    }
    return result;
  }

  public BBaumseite minSchlSeite(BBaumseite Start) {
    BBaumseite q=Start;
    if (q!=null) {
      while (((BBaumzeile) q.getElement(0)).Sohn!=null)
        q=((BBaumzeile) q.getElement(0)).Sohn;
    }
    return q;
  }

  public BBaumseite maxSchlSeite(BBaumseite Start) {
    BBaumseite q=Start;
    if (q!=null) {
      while (((BBaumzeile) q.getElement(q.count()-1)).Sohn!=null)
        q=((BBaumzeile) q.getElement(q.count()-1)).Sohn;
    }
    return q;
  }

  public int Hoehe(BBaumseite Start) {
    int        result=0;
    BBaumseite p=Start;

    while (p!=null) { result++; p=((BBaumzeile) p.getElement(0)).Sohn; }
    return result;
  }

  public SeiteInt suchPos(String S, BBaumseite Start) {
    boolean    found=false;
    boolean    Abbr=false;
    int        SuchPos, i=-1, j;
    BBaumseite result=Start;
    BBaumzeile aktZeile;
    while (!(found || Abbr)) {
      i=result.suchPos(S); //Suche auf Seite == Suche in sort. Liste
      found=(i>=0); if (found) j=i; else j=-(i+1);
      aktZeile=(BBaumzeile) result.getElement(j-1);
      Abbr=aktZeile.Sohn==null;
      if (!(found || Abbr)) result=aktZeile.Sohn;
    }
    return new SeiteInt(result,i);
  }

  public int[] EtagOrd(String S, BBaumseite Start) {
    boolean    found=false;
    boolean    Abbr=false;
    int        SuchPos, i=-1, j=-1;
    BBaumseite result=Start;
    BBaumzeile aktZeile;
    int        Etage=0;
    int        EtgOrd=0;
    int        hoehe=Hoehe(Wurzel);

    while (!(found || Abbr)) {
      i=result.suchPos(S); //Suche auf Seite == Suche in sort. Liste
      found=(i>=0); if (found) j=i; else j=-(i+1);
      aktZeile=(BBaumzeile) result.getElement(j-1);
      Abbr=aktZeile.Sohn==null;
      if (!(found || Abbr)) {
        result=aktZeile.Sohn;
        Etage++;
        EtgOrd=EtgOrd*(2*m+1)+j-1;
      }
    }
    return new int[]{Etage,j,EtgOrd};
  }

  public Elementtyp suchen(String S) {
    SeiteInt     SuchKn=suchPos(S,Wurzel);
    BBaumseite   BBS=SuchKn.getSeite();
    int          i=SuchKn.getInt();
    boolean      found=i>=0;

    if (found) return ((BBaumzeile) BBS.getElement(i)).Inhalt;
    else return null;
  }

  private void SohnVaterAbstimmung(BBaumseite p) {
    if ((p!=null) && (((BBaumzeile) p.getElement(0)).Sohn!=null))
      for (int i=0; i<p.count(); i++) {
        BBaumseite q=((BBaumzeile) p.getElement(i)).Sohn;
        if (q!=null) { q.Vater=p; q.Vaterzeile=i; }
      }
  }

  private void einfueg(Elementtyp e, BBaumseite p, int i, BBaumseite Shn) {
    BBaumseite q;
    int        j;
    p.insert(new BBaumzeile(e,Shn),i);
    SohnVaterAbstimmung(p);
    if (p.count()==2*(m+1)) {
      q=new BBaumseite(m,((BBaumzeile) p.getElement(m+1)).Sohn);
      for (j=1; j<=m; j++) {
        q.add((Elementtyp) p.getElement(m+2)); p.remove(m+2);
      }
      SohnVaterAbstimmung(q);
      e=((BBaumzeile) p.getElement(m+1)).Inhalt;
      i=p.Vaterzeile+1;
      p.remove(m+1);
      if (p.Vater==null) {
        Wurzel=new BBaumseite(m,Wurzel);
        Wurzel.insert(new BBaumzeile(e,q),i);
        SohnVaterAbstimmung(Wurzel);
      }
      else einfueg(e,p.Vater,i,q);
    }
  }

  public boolean einfuegen(Elementtyp e) {
    SeiteInt     SuchPos;
    String       S=e.getSchluessel();
    boolean      found=false;
    int          i;

    if (Wurzel==null) {
      Wurzel=new BBaumseite(m,null);
      Wurzel.add(new BBaumzeile(e,null));
    }
    else {
      SuchPos=suchPos(S,Wurzel);
      i=SuchPos.getInt();
      found=i>=0;
      if (!found)
        einfueg(e,SuchPos.getSeite(),-(i+1),null);
    }
    return !found;
  }

  private void verschmelzen(BBaumseite q, BBaumseite p)
  // Auffuellen der Seite q durch die Vaterzeile der Seite p und den Inhalt von p
  { q.add(new BBaumzeile(((BBaumzeile) p.Vater.getElement(p.Vaterzeile)).Inhalt,
                         ((BBaumzeile) p.getElement(0)).Sohn));
    for (int i=1; i<p.count(); i++) q.add((Elementtyp) p.getElement(i));
    p=null;
    SohnVaterAbstimmung(q);
  }

  private void AuffuellenRL(BBaumseite p, BBaumseite q)
  //Auffuellen der Seite p durch Einschieben der Vaterzeile als erste Zeile;
  //die Vaterzeile wird durch die letzte Zeile der Seite q ersetzt;
  { p.insert(new BBaumzeile(((BBaumzeile) p.Vater.getElement(p.Vaterzeile)).Inhalt,
                                        ((BBaumzeile) p.getElement(0)).Sohn),1);
    ((BBaumzeile) p.Vater.getElement(p.Vaterzeile)).Inhalt=
                                ((BBaumzeile) q.getElement(q.count()-1)).Inhalt;
    ((BBaumzeile) p.getElement(0)).Sohn=
                                ((BBaumzeile) q.getElement(q.count()-1)).Sohn;
    SohnVaterAbstimmung(p);
    q.remove(q.count()-1);
    SohnVaterAbstimmung(q);
  }

  private void AuffuellenLR(BBaumseite p, BBaumseite q)
  //Auffuellen der Seite p durch Anhaengen der (Vaterzeile+1) als letzte Zeile;
  //(Vaterzeile+1) wird durch die erste Zeile der Seite q ersetzt;
  { p.add(new BBaumzeile(((BBaumzeile) p.Vater.getElement(p.Vaterzeile+1)).Inhalt,
                         ((BBaumzeile) q.getElement(0)).Sohn));
    ((BBaumzeile) p.Vater.getElement(p.Vaterzeile+1)).Inhalt=
                                        ((BBaumzeile) q.getElement(1)).Inhalt;
    ((BBaumzeile) q.getElement(0)).Sohn=((BBaumzeile) q.getElement(1)).Sohn;
    SohnVaterAbstimmung(p);
    q.remove(1);
    SohnVaterAbstimmung(q);
  }

  private void entfern(BBaumseite p, int i) {
    BBaumseite q,pV;
    int        iV;

    p.remove(i);
    SohnVaterAbstimmung(p);
    if (((p!=Wurzel) && (p.count()==m)) || ((p==Wurzel) && (p.count()==1))) {
      if (p==Wurzel) {
        Wurzel=((BBaumzeile) Wurzel.getElement(0)).Sohn;
        if (Wurzel!=null) Wurzel.Vater=null;
      }
      else {
        pV=p.Vater; iV=p.Vaterzeile;
        if (iV>0) {
          q=((BBaumzeile) pV.getElement(iV-1)).Sohn;
          if (q.count()==m+1) {
            verschmelzen(q,p);
            entfern(pV,iV);
          }
          else AuffuellenRL(p,q);
        }
        else {
          q=((BBaumzeile) pV.getElement(1)).Sohn;
          if (q.count()==m+1) {
            verschmelzen(p,q);
            entfern(pV,1);
          }
          else AuffuellenLR(p,q);
        }
      }
    }
  }

  public boolean entfernen(String S) {
    BBaumseite   p,q,pFound; int i,iFound;
    SeiteInt     SuchPos=suchPos(S,Wurzel);
    i=SuchPos.getInt();
    boolean found=i>=0;
    if (found) {
      pFound=SuchPos.getSeite();
      iFound=i;
      q=((BBaumzeile) pFound.getElement(iFound)).Sohn;
      if (q!=null) {  //pFound ist kein Blatt
        SuchPos=suchPos(S,q);
        p=SuchPos.getSeite();
        i=-(SuchPos.getInt()+1);
        ((BBaumzeile) pFound.getElement(iFound)).Inhalt
                                         =((BBaumzeile) p.getElement(i)).Inhalt;
      }
      else { p=pFound; i=iFound; }
      entfern(p,i);
    }
    return found;
  }

  public int BHoch(int B, int k) {
    int Result=1; for (int i=1; i<=k; i++) Result=Result*B;
    return Result;
  }

  public void Seitenausgabe(BBaumseite p, int Spalte, int Etage,
                            int Baumhoehe, JTable T)              {
    int i, Zeile, Abstand;  String S;
    if (p!=null) {
      if (Etage==0) Zeile=0; else Zeile=Etage*(2*m+1);
      int elAnz=p.count();
      for (i=1; i<p.count(); i++) {
        if (((BBaumzeile) p.getElement(i)).Inhalt!=null)
          S=((BBaumzeile) p.getElement(i)).getSchluessel(); else S="null";
        T.setValueAt(S,Zeile+i-1,Spalte);
      }
      Abstand=BHoch(2*m+1,Baumhoehe-(Etage+2));
      for (i=0; i<p.count(); i++)
        if (((BBaumzeile) p.getElement(i)).Sohn!=null)
          Seitenausgabe(((BBaumzeile) p.getElement(i)).Sohn,
                          Spalte+i*Abstand,Etage+1,Baumhoehe,T);
    }
    else T.setValueAt("leer",0,0);
  }

  public void BaumAusgabe(JTable T, BBaumseite Kn) {
    int H=Hoehe(Kn);
    if (Kn==null) T.setValueAt("leer",0,0);
    else {
      for (int i=0; i<T.getRowCount(); i++)
        for (int j=0; j<T.getColumnCount(); j++)
          T.setValueAt("",i,j);
     Seitenausgabe(Kn,0,0,H,T);
    }
  }

  class SeiteInt {
    BBaumseite Seite; int I;

    public SeiteInt(BBaumseite Seite, int i) {
      this.Seite=Seite; I=i;
    }

    public BBaumseite getSeite() { return Seite; }

    public int getInt() { return I; }

  }

}