package ADS;

/**
 * berschrift:   Classes zur LV  "Algorithmen u. Datenstrukturen"
 * Beschreibung:
 * Copyright:     Copyright (c) 2002
 * Organisation:  HTWK Leipzig, Fb IMN
 * @author Prof. Dr. G. Ngler
 * @version 1.0
 */
import java.io.*;

public class ElementtypI extends Elementtyp
/** Elementtyp, aus ganzen Zahlen; Schlssel ist Zahl rechtsbndig als String
  */
{
  int inhalt;

  public ElementtypI(int i) {
    inhalt=i;
  }

  public static ElementtypI laden(DataInputStream f) {
    ElementtypI e;
    try { int inh=f.readInt();
    e=new ElementtypI(inh); }
    catch (IOException ioe) { e=null; }
    return e;
  }

  public void speichern(DataOutputStream f) {
    try { f.writeInt(inhalt); }
    catch (IOException ioe) {  }
  }

  public String getSchluessel() {  return ZahlZuSchl(inhalt); }

  public int getInhalt() { return inhalt; }

  public boolean BitWert(int k) {
    final int[] StBit=
                 {1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768};
    return (inhalt & StBit[k])==StBit[k];
  }

}
