package ADS;

/**
 * berschrift:   Classes zur LV  "Algorithmen u. Datenstrukturen"
 * Beschreibung:
 * Copyright:     Copyright (c) 2002
 * Organisation:  HTWK Leipzig, Fb IMN
 * @author Prof. Dr. G. Ngler
 * @version 1.0
 */

public class Hashing extends Heap {
  protected final int Prim=5149; int Anz;

  public Hashing() {  super(5149); n=Prim; Anz=0; }

  public Hashing(int dimension) { super(dimension);  n=dimension; Anz=0; }

  public int Hashfkt(String S) {
    int v=0;
    for (int j=0; j<Elementtyp.AnzSchlSt; j++)
      v=(v*Elementtyp.Radix+Elementtyp.ZWert(S,j)) % n;
    return v;
  }

  public boolean istLeer() { return Anz==0; }

  public boolean istVoll() { return Anz==maxAnz; }

  public int count() { return Anz; }

  class HashItem extends Elementtyp {
    protected Elementtyp Inhalt=null;

    public HashItem() {  }

    public HashItem(Elementtyp e) { Inhalt=e;  }

    public String getSchluessel() {
      if (Inhalt!=null) return Inhalt.getSchluessel(); else return "";
    }
  }
}