package adsuebungen;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import sun.awt.image.*;
import com.borland.jbcl.layout.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class ADS_HptFrame extends JFrame {
  JPanel contentPane;
  JMenuBar jHauptmenue = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem SchlgTstStart = new JMenuItem();
  JMenuItem About = new JMenuItem();
  XYLayout xYLayout1 = new XYLayout();
  JMenuItem AListeTstStart = new JMenuItem();
  JMenuItem GraphTstStart = new JMenuItem();
  JMenuItem Graph2TstStart = new JMenuItem();
  JMenuItem SortTstStart = new JMenuItem();
  JMenu HashTstStart = new JMenu();
  JMenuItem HashKett = new JMenuItem();
  JMenuItem HashCoal = new JMenuItem();
  JMenuItem HashDopp = new JMenuItem();
  JMenuItem AVLTstStart = new JMenuItem();
  JMenuItem SuchTstStart = new JMenuItem();
  JMenuItem SegBaumTstStart = new JMenuItem();
  JMenu eNetzTstStart = new JMenu();
  JMenuItem eNetzKurzStart = new JMenuItem();
  JMenuItem eNetzLangStart = new JMenuItem();
  JMenuItem KnapsackTstStart = new JMenuItem();

  //Construct the frame
  public ADS_HptFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(xYLayout1);
    this.setEnabled(true);
    this.setSize(new Dimension(400, 305));
    this.setTitle("bungsprogramme zur Lehrveranstaltung ADS");
    jMenuFile.setText("Start");
    jMenuFileExit.setText("Programm beenden");
    jMenuFileExit.addActionListener(new ADS_HptFrame_jMenuFileExit_ActionAdapter(this));
    jMenuHelp.setText("Hilfe");
    SchlgTstStart.setAction(null);
    SchlgTstStart.setText("1. Schlange - Test");
    SchlgTstStart.addActionListener(new ADS_HptFrame_SchlgTstStart_actionAdapter(this));
    About.setText("ber");
    contentPane.setBackground(SystemColor.control);
    contentPane.setEnabled(true);
    contentPane.setOpaque(true);
    contentPane.setRequestFocusEnabled(true);
    jHauptmenue.setVerifyInputWhenFocusTarget(false);
    AListeTstStart.setText("2. AListe - Test");
    AListeTstStart.addActionListener(new ADS_HptFrame_AListeTstStart_actionAdapter(this));
    GraphTstStart.setText("3. Graph - Zyklen/Cozyklen");
    GraphTstStart.addActionListener(new ADS_HptFrame_GraphTstStart_actionAdapter(this));
    Graph2TstStart.setText("4. Graph - Eigenschaften");
    Graph2TstStart.addActionListener(new ADS_HptFrame_Graph2TstStart_actionAdapter(this));
    SortTstStart.setText("5. Zeitmessung bei Sortierung");
    SortTstStart.addActionListener(new ADS_HptFrame_SortTstStart_actionAdapter(this));
    HashTstStart.setText("6. Hashverfahren - Test");
    HashKett.setText("HashKett");
    HashKett.addActionListener(new ADS_HptFrame_HashKett_actionAdapter(this));
    HashCoal.setText("HashCoal");
    HashCoal.addActionListener(new ADS_HptFrame_HashCoal_actionAdapter(this));
    HashDopp.setText("HashDopp");
    HashDopp.addActionListener(new ADS_HptFrame_HashDopp_actionAdapter(this));
    AVLTstStart.setText("7. AVLBaum - Test");
    AVLTstStart.addActionListener(new ADS_HptFrame_AVLTstStart_actionAdapter(this));
    SuchTstStart.setText("8. Zeitmessung bei Suchen");
    SuchTstStart.addActionListener(new ADS_HptFrame_SuchTstStart_actionAdapter(this));
    SegBaumTstStart.setText("9. Segmentbaum - Test");
    SegBaumTstStart.addActionListener(new ADS_HptFrame_SegBaumTstStart_actionAdapter(this));
    eNetzTstStart.setText("10. eNetz - Test");
    eNetzKurzStart.setText("krzeste Wege");
    eNetzKurzStart.addActionListener(new ADS_HptFrame_eNetzKurzStart_actionAdapter(this));
    eNetzLangStart.setText("lngste Wege");
    eNetzLangStart.addActionListener(new ADS_HptFrame_eNetzLangStart_actionAdapter(this));
    KnapsackTstStart.setText("11. Knappsack - Problem");
    KnapsackTstStart.addActionListener(new ADS_HptFrame_KnapsackTstStart_actionAdapter(this));
    jMenuFile.add(SchlgTstStart);
    jMenuFile.add(AListeTstStart);
    jMenuFile.add(GraphTstStart);
    jMenuFile.add(Graph2TstStart);
    jMenuFile.add(SortTstStart);
    jMenuFile.add(HashTstStart);
    jMenuFile.add(AVLTstStart);
    jMenuFile.add(SuchTstStart);
    jMenuFile.add(SegBaumTstStart);
    jMenuFile.add(eNetzTstStart);
    jMenuFile.add(KnapsackTstStart);
    jMenuFile.addSeparator();
    jMenuFile.add(jMenuFileExit);
    jHauptmenue.add(jMenuFile);
    jHauptmenue.add(jMenuHelp);
    jMenuHelp.add(About);
    HashTstStart.add(HashKett);
    HashTstStart.add(HashCoal);
    HashTstStart.add(HashDopp);
    eNetzTstStart.add(eNetzKurzStart);
    eNetzTstStart.add(eNetzLangStart);
    this.setJMenuBar(jHauptmenue);
  }

  //File | Exit action performed
  public void jMenuFileExit_actionPerformed(ActionEvent e) {
    System.exit(0);
  }

  void SchlgTstStart_actionPerformed(ActionEvent e){
    Dialog_Schlg dialog_Schlg = new Dialog_Schlg(this,"Test der Schlangen-Implementierung",true);
    Dimension dialog_SchlgSize = dialog_Schlg.getPreferredSize();
    Dimension frmAusSize = getSize();
    Point locAus = getLocation();

    dialog_Schlg.setLocation( (frmAusSize.width  - dialog_SchlgSize.width) / 2 + locAus.x,
                              (frmAusSize.height - dialog_SchlgSize.height) / 2 + locAus.y);
    dialog_Schlg.show();
  }

  //Help | About action performed
  //...

  void AListeTstStart_actionPerformed(ActionEvent e) {
    Dialog_Liste dialog_Liste = new Dialog_Liste(this,"Test der Listen-Implementierung",true);
    Dimension dialog_ListeSize = dialog_Liste.getPreferredSize();
    Dimension frmAusSize = getSize();
    Point locAus = getLocation();

    dialog_Liste.setLocation( (frmAusSize.width  - dialog_ListeSize.width) / 2 + locAus.x,
                              (frmAusSize.height - dialog_ListeSize.height) / 2 + locAus.y);
    dialog_Liste.show();
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      jMenuFileExit_actionPerformed(null);
    }
  }

  void GraphTstStart_actionPerformed(ActionEvent e) {
    Dialog_Graph dialog_Graph = new Dialog_Graph(this,"Basis-Zyklen und -Cozyklen",true);
    Dimension dialog_GraphSize = dialog_Graph.getPreferredSize();
    Dimension frmAusSize = getSize();
    Point locAus = getLocation();
    dialog_Graph.setLocation( (frmAusSize.width  - dialog_GraphSize.width) / 2 + locAus.x,
                              (frmAusSize.height - dialog_GraphSize.height) / 2 + locAus.y);
    dialog_Graph.show();
  }

  void Graph2TstStart_actionPerformed(ActionEvent e) {
    Dialog_Graph2 dialog_Graph = new Dialog_Graph2(this,"Basis-Zyklen und -Cozyklen",true);
    Dimension dialog_GraphSize = dialog_Graph.getPreferredSize();
    Dimension frmAusSize = getSize();
    Point locAus = getLocation();
    dialog_Graph.setLocation( (frmAusSize.width  - dialog_GraphSize.width) / 2 + locAus.x,
                              (frmAusSize.height - dialog_GraphSize.height) / 2 + locAus.y);
    dialog_Graph.show();
  }

  void SortTstStart_actionPerformed(ActionEvent e) {
    Dialog_Sort dialog_Sort = new Dialog_Sort(this,"Zeitmessung von Sortierverfahren - Matthias Jauernig, 03In1",true);
    Dimension dialog_SortSize = dialog_Sort.getPreferredSize();
    Dimension frmAusSize = getSize();
    Point locAus = getLocation();
    dialog_Sort.setLocation( (frmAusSize.width  - dialog_SortSize.width) / 2 + locAus.x,
                              (frmAusSize.height - dialog_SortSize.height) / 2 + locAus.y);
    dialog_Sort.show();
  }

  void HashKett_actionPerformed(ActionEvent e) {
    Dialog_HashKett dialog_HashKett = new Dialog_HashKett(this,"Hashing mit berluferketten auerhalb",true);
    Dimension dialog_HashKettSize = dialog_HashKett.getPreferredSize();
    Dimension frmAusSize = getSize();
    Point locAus = getLocation();
    dialog_HashKett.setLocation( (frmAusSize.width  - dialog_HashKettSize.width) / 2 + locAus.x,
                              (frmAusSize.height - dialog_HashKettSize.height) / 2 + locAus.y);
    dialog_HashKett.show();
  }

  void HashDopp_actionPerformed(ActionEvent e) {
    Dialog_HashCuD dialog_HashCuD = new Dialog_HashCuD(this,"Hashing mit berluferketten innerhalb - Doublehashing",true);
    Dimension dialog_HashCuDSize = dialog_HashCuD.getPreferredSize();
    Dimension frmAusSize = getSize();
    Point locAus = getLocation();
    dialog_HashCuD.setLocation( (frmAusSize.width  - dialog_HashCuDSize.width) / 2 + locAus.x,
                              (frmAusSize.height - dialog_HashCuDSize.height) / 2 + locAus.y);
    dialog_HashCuD.starten(2);
  }

  void HashCoal_actionPerformed(ActionEvent e) {
    Dialog_HashCuD dialog_HashCuD = new Dialog_HashCuD(this,"Hashing mit berluferketten innerhalb - Coalesced Hashing",true);
    Dimension dialog_HashCuDSize = dialog_HashCuD.getPreferredSize();
    Dimension frmAusSize = getSize();
    Point locAus = getLocation();
    dialog_HashCuD.setLocation( (frmAusSize.width  - dialog_HashCuDSize.width) / 2 + locAus.x,
                              (frmAusSize.height - dialog_HashCuDSize.height) / 2 + locAus.y);
    dialog_HashCuD.starten(1);
  }

  void AVLTstStart_actionPerformed(ActionEvent e) {
      Dialog_AVLBaum dialog_AVLBaum = new Dialog_AVLBaum(this,"AVLBaum - Test",true);
      Dimension dialog_AVLBaumSize = dialog_AVLBaum.getPreferredSize();
      Dimension frmAusSize = getSize();
      Point locAus = getLocation();
      dialog_AVLBaum.setLocation( (frmAusSize.width  - dialog_AVLBaumSize.width) / 2 + locAus.x,
                                (frmAusSize.height - dialog_AVLBaumSize.height) / 2 + locAus.y);
      dialog_AVLBaum.show();
  }

  void SuchTstStart_actionPerformed(ActionEvent e) {
      Dialog_Such dialog_Such = new Dialog_Such(this,"Zeitvergleich von Such-Algorithmen",true);
      Dimension dialog_SuchSize = dialog_Such.getPreferredSize();
      Dimension frmAusSize = getSize();
      Point locAus = getLocation();
      dialog_Such.setLocation( (frmAusSize.width  - dialog_SuchSize.width) / 2 + locAus.x,
                                (frmAusSize.height - dialog_SuchSize.height) / 2 + locAus.y);
      dialog_Such.show();
  }

  void SegBaumTstStart_actionPerformed(ActionEvent e) {
    Dialog_SegBaum dialog_SegBaum = new Dialog_SegBaum(this,"Test der Segmentbaum-Implementierung",true);
    Dimension dialog_SegBaumSize = dialog_SegBaum.getPreferredSize();
    Dimension frmAusSize = getSize();
    Point locAus = getLocation();
    dialog_SegBaum.setLocation( (frmAusSize.width  - dialog_SegBaumSize.width) / 2 + locAus.x,
                              (frmAusSize.height - dialog_SegBaumSize.height) / 2 + locAus.y);
    dialog_SegBaum.show();
  }

  void eNetzKurzStart_actionPerformed(ActionEvent e) {
    Dialog_eNetz dialog_eNetz = new Dialog_eNetz(this,"Test des Dijkstra-Algorithmus' - krzeste Wege",true);
    Dimension dialog_eNetzSize = dialog_eNetz.getPreferredSize();
    Dimension frmAusSize = getSize();
    Point locAus = getLocation();
    dialog_eNetz.setLocation( (frmAusSize.width  - dialog_eNetzSize.width) / 2 + locAus.x,
                              (frmAusSize.height - dialog_eNetzSize.height) / 2 + locAus.y);
    dialog_eNetz.zeigen(-1);
  }

  void eNetzLangStart_actionPerformed(ActionEvent e) {
    Dialog_eNetz dialog_eNetz = new Dialog_eNetz(this,"Test des Dijkstra-Algorithmus' - lngste Wege",true);
    Dimension dialog_eNetzSize = dialog_eNetz.getPreferredSize();
    Dimension frmAusSize = getSize();
    Point locAus = getLocation();
    dialog_eNetz.setLocation( (frmAusSize.width  - dialog_eNetzSize.width) / 2 + locAus.x,
                              (frmAusSize.height - dialog_eNetzSize.height) / 2 + locAus.y);
    dialog_eNetz.zeigen(1);
  }

  void KnapsackTstStart_actionPerformed(ActionEvent e) {
    Dialog_Knapsack dialog_Knapsack = new Dialog_Knapsack(this,"Knapsack-Problem - Matthias Jauernig, 03In1",true);
    Dimension dialog_KnapsackSize = dialog_Knapsack.getPreferredSize();
    Dimension frmAusSize = getSize();
    Point locAus = getLocation();
    dialog_Knapsack.setLocation( (frmAusSize.width  - dialog_KnapsackSize.width) / 2 + locAus.x,
                              (frmAusSize.height - dialog_KnapsackSize.height) / 2 + locAus.y);
    dialog_Knapsack.show();
  }
}

class ADS_HptFrame_jMenuFileExit_ActionAdapter implements ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_jMenuFileExit_ActionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuFileExit_actionPerformed(e);
  }
}

class ADS_HptFrame_SchlgTstStart_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_SchlgTstStart_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.SchlgTstStart_actionPerformed(e);
  }
}

class ADS_HptFrame_AListeTstStart_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_AListeTstStart_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.AListeTstStart_actionPerformed(e);
  }
}

class ADS_HptFrame_GraphTstStart_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_GraphTstStart_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.GraphTstStart_actionPerformed(e);
  }
}

class ADS_HptFrame_Graph2TstStart_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_Graph2TstStart_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.Graph2TstStart_actionPerformed(e);
  }
}

class ADS_HptFrame_SortTstStart_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_SortTstStart_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.SortTstStart_actionPerformed(e);
  }
}

class ADS_HptFrame_HashKett_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_HashKett_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.HashKett_actionPerformed(e);
  }
}

class ADS_HptFrame_HashDopp_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_HashDopp_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.HashDopp_actionPerformed(e);
  }
}

class ADS_HptFrame_HashCoal_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_HashCoal_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.HashCoal_actionPerformed(e);
  }
}

class ADS_HptFrame_AVLTstStart_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_AVLTstStart_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.AVLTstStart_actionPerformed(e);
  }
}

class ADS_HptFrame_SuchTstStart_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_SuchTstStart_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.SuchTstStart_actionPerformed(e);
  }
}

class ADS_HptFrame_SegBaumTstStart_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_SegBaumTstStart_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.SegBaumTstStart_actionPerformed(e);
  }
}

class ADS_HptFrame_eNetzKurzStart_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_eNetzKurzStart_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.eNetzKurzStart_actionPerformed(e);
  }
}

class ADS_HptFrame_eNetzLangStart_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_eNetzLangStart_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.eNetzLangStart_actionPerformed(e);
  }
}

class ADS_HptFrame_KnapsackTstStart_actionAdapter implements java.awt.event.ActionListener {
  ADS_HptFrame adaptee;

  ADS_HptFrame_KnapsackTstStart_actionAdapter(ADS_HptFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.KnapsackTstStart_actionPerformed(e);
  }
}