package adsuebungen;

import ADS.*;
import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author unbekannt
 * @version 1.0
 */

public class Dialog_Graph extends JDialog {
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  JButton EndeBtn = new JButton();
  JTextArea tb = new JTextArea();
  TitledBorder titledBorder3;
  JTextArea ta = new JTextArea();

  public Dialog_Graph(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public Dialog_Graph() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    titledBorder1 = new TitledBorder("");
    titledBorder2 = new TitledBorder("");
    titledBorder3 = new TitledBorder("");
    panel1.setLayout(borderLayout1);
    this.getContentPane().setLayout(xYLayout1);
    xYLayout1.setWidth(435);
    xYLayout1.setHeight(404);
    EndeBtn.setBackground(Color.white);
    EndeBtn.setEnabled(true);
    EndeBtn.setAlignmentX( (float) 0.0);
    EndeBtn.setBorder(BorderFactory.createEtchedBorder());
    EndeBtn.setDebugGraphicsOptions(0);
    EndeBtn.setActionCommand("Beenden");
    EndeBtn.setContentAreaFilled(true);
    EndeBtn.setText("Beenden");
    EndeBtn.addActionListener(new Dialog_Graph_EndeBtn_actionAdapter(this));
    tb.setBorder(BorderFactory.createEtchedBorder());
    tb.setEditable(false);
    this.getContentPane().setBackground(Color.white);
    ta.setEditable(false);
    ta.setBorder(BorderFactory.createEtchedBorder());
    this.getContentPane().add(panel1, new XYConstraints(75, 49, -1, -1));
    this.getContentPane().add(EndeBtn,                     new XYConstraints(169, 366, 97, 33));
    this.getContentPane().add(tb,    new XYConstraints(7, 181, 421, 179));
    this.getContentPane().add(ta,      new XYConstraints(7, 8, 421, 176));

    //Graphen erstellen und Operationen darauf ausfhren:////////////////////
    Graph G1=new Graph(5,8);
    Graph G2=new Graph(5,8);

    //Aufbau der Gerstbgen beider Graphen
    G1.insertBg("1","2"); G2.insertBg("1","2");
    G1.insertBg("2","3"); G2.insertBg("2","3");
    G1.insertBg("3","4"); G2.insertBg("3","4");
    G1.insertBg("4","5"); G2.insertBg("4","5");
    //Aufbau der Cogerstbgen beider Graphen
    G1.insertBg("2","4"); G2.insertBg("2","4");
    G1.insertBg("4","1"); G2.insertBg("4","1");
    G1.insertBg("1","3"); G2.insertBg("1","3");
    G1.insertBg("3","5"); G2.insertBg("3","5");
    //G1 erhlt Gerst    //G2 erhlt Cogerst
    G1.initStzBg(1);      G2.initStzBg(2);
    G1.setStzBg(2,1);     G2.setStzBg(4,5);
    G1.setStzBg(3,2);     G2.setStzBg(1,6);
    G1.setStzBg(4,3);     G2.setStzBg(3,7);
    G1.setStzBg(5,4);     G2.setStzBg(5,8);

    //Ausgabe der Basiszyklen und -cozyklen
    ta.append("G1:\n");
    ta.append("z(5)="+G1.printZyklus(5)+"\n");
    ta.append("z(6)="+G1.printZyklus(6)+"\n");
    ta.append("z(7)="+G1.printZyklus(7)+"\n");
    ta.append("z(8)="+G1.printZyklus(8)+"\n");
    ta.append("cz(1)="+G1.printCozyklus(1)+"\n");
    ta.append("cz(2)="+G1.printCozyklus(2)+"\n");
    ta.append("cz(3)="+G1.printCozyklus(3)+"\n");
    ta.append("cz(4)="+G1.printCozyklus(4)+"\n\n");
    tb.append("G2:\n");
    tb.append("z(1)="+G2.printZyklus(1)+"\n");
    tb.append("z(2)="+G2.printZyklus(2)+"\n");
    tb.append("z(3)="+G2.printZyklus(3)+"\n");
    tb.append("z(4)="+G2.printZyklus(4)+"\n");
    tb.append("cz(5)="+G2.printCozyklus(5)+"\n");
    tb.append("cz(6)="+G2.printCozyklus(6)+"\n");
    tb.append("cz(7)="+G2.printCozyklus(7)+"\n");
    tb.append("cz(8)="+G2.printCozyklus(8));
}

  void EndeBtn_actionPerformed(ActionEvent e) {
    dispose();
  }
}


class Dialog_Graph_EndeBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_Graph adaptee;

  Dialog_Graph_EndeBtn_actionAdapter(Dialog_Graph adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.EndeBtn_actionPerformed(e);
  }
}