package adsuebungen;

import ADS.*;
import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author unbekannt
 * @version 1.0
 */

public class Dialog_HashCuD extends JDialog {
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JButton OKBtn = new JButton();
  JButton EndeBtn = new JButton();
  JTextField textfeld = new JTextField();
  JScrollPane jScrollPane1 = new JScrollPane();
  String[] TabKopf = new String[] {
      "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13",
      "14", "15", "16", "17", "18"};
  String[][] Tab = new String[2][19];
  JTable jTable1 = new JTable(Tab, TabKopf);
  Schlange HashCuD;
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  int hashart;
  SuchStruk hash=null;

  public Dialog_HashCuD(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public Dialog_HashCuD() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    titledBorder1 = new TitledBorder("");
    titledBorder2 = new TitledBorder("");
    panel1.setLayout(borderLayout1);
    this.getContentPane().setLayout(xYLayout1);
    jLabel1.setRequestFocusEnabled(true);
    jLabel1.setText("+S fr einfuegen(S), -S fr entfernen(S), ?S fr suchen(S)");
    jLabel2.setText("Eingaben");
    OKBtn.setActionCommand("OK");
    OKBtn.setText("Ausfhren");
    OKBtn.addActionListener(new Dialog_HashCuD_OKBtn_actionAdapter(this));
    EndeBtn.setEnabled(true);
    EndeBtn.setAlignmentX( (float) 0.0);
    EndeBtn.setDebugGraphicsOptions(0);
    EndeBtn.setActionCommand("Ende");
    EndeBtn.setContentAreaFilled(true);
    EndeBtn.setText("Ende");
    EndeBtn.addActionListener(new Dialog_HashCuD_EndeBtn_actionAdapter(this));
    textfeld.setText("");
    xYLayout1.setWidth(731);
    xYLayout1.setHeight(176);
    jTable1.setFont(new java.awt.Font("Dialog", 0, 10));
    jTable1.setBorder(BorderFactory.createRaisedBevelBorder());
    jScrollPane1.setEnabled(true);
    jScrollPane1.setForeground(Color.black);
    jScrollPane1.setBorder(titledBorder2);
    jScrollPane1.setDebugGraphicsOptions(0);
    this.getContentPane().add(panel1, new XYConstraints(75, 49, -1, -1));
    this.getContentPane().add(jScrollPane1,  new XYConstraints(3, 72, 726, 68));
    this.getContentPane().add(jLabel1, new XYConstraints(25, 43, -1, -1));
    this.getContentPane().add(jLabel2, new XYConstraints(24, 13, 69, -1));
    this.getContentPane().add(textfeld, new XYConstraints(114, 9, 184, 26));
    this.getContentPane().add(EndeBtn,     new XYConstraints(319, 145, 92, -1));
    this.getContentPane().add(OKBtn, new XYConstraints(332, 9, 122, -1));
    jScrollPane1.getViewport().add(jTable1, null);
    jTable1.setColumnSelectionAllowed(true);
  }

  void starten(int art){ //art=1: Coal; art=2:Dopp
    hashart=art;
    if(art==1){
      hash = new HashCoal(19);
      ((HashCoal)hash).Ausg(jTable1);
    }
    else{
      hash = new HashDopp(19);
      ((HashDopp)hash).Ausg(jTable1);
    }
    show();
  }

  void EndeBtn_actionPerformed(ActionEvent e) {
    dispose();
  }

  void OKBtn_actionPerformed(ActionEvent e1) {
    int i;
    boolean ok;
    String S = textfeld.getText();
    JOptionPane jOptPan = new JOptionPane();
    if (S.length() > 0) {
      char c = S.charAt(0);
      S = S.substring(1);
      ElementtypS e=new ElementtypS(S);
      jTable1.clearSelection();
      switch (c) {
        case '+':
          ok=hash.einfuegen(e);
          if(!ok) jOptPan.showMessageDialog(this,"Element '"+S+"' schon in der "+
                          "Hashtabelle vorhanden oder Hashtabelle voll!");
          break;
        case '-':
          if(!hash.entfernen(e.getSchluessel())) jOptPan.showMessageDialog(this,"Element '"+S+
                          "' konnte nicht gefunden werden!");
          break;
        case '?':
          Elementtyp d=hash.suchen(e.getSchluessel());
          if(d==null || !d.getSchluessel().equals(e.getSchluessel()))
            jOptPan.showMessageDialog(this,"Element '"+S+"' wurde nicht gefunden!");
          else{
            int suchpos;
            if(hashart==1) suchpos=((HashCoal)hash).suchPos(e.getSchluessel());
            else suchpos=((HashDopp)hash).suchPos(e.getSchluessel());
            jTable1.changeSelection(0,suchpos,false,false);
          }
          break;
      }
      if(c=='+' || c=='-')
        if(hashart==1) ((HashCoal)hash).Ausg(jTable1);
        else ((HashDopp)hash).Ausg(jTable1);
    }
  }
}


class Dialog_HashCuD_EndeBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_HashCuD adaptee;

  Dialog_HashCuD_EndeBtn_actionAdapter(Dialog_HashCuD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.EndeBtn_actionPerformed(e);
  }
}

class Dialog_HashCuD_OKBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_HashCuD adaptee;

  Dialog_HashCuD_OKBtn_actionAdapter(Dialog_HashCuD adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.OKBtn_actionPerformed(e);
  }
}
