package adsuebungen;

import ADS.*;
import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Matthias Jauernig
 * @version 1.0
 */

public class Dialog_Knapsack extends JDialog {
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  JLabel jLabel2 = new JLabel();
  JButton OKBtn = new JButton();
  JButton EndeBtn = new JButton();
  JTextField textfeld = new JTextField();
  JScrollPane jScrollPane1 = new JScrollPane();
  int maxanz=15;
  String[] TabKopf = new String[] {
      "Gegenstand","Gewicht","Wert",""};
  String[][] Tab = new String[maxanz+1][4];
  JTable jT = new JTable(Tab, TabKopf);
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;

  public Dialog_Knapsack(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public Dialog_Knapsack() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    titledBorder1 = new TitledBorder("");
    titledBorder2 = new TitledBorder("");
    panel1.setLayout(borderLayout1);
    this.getContentPane().setLayout(xYLayout1);
    jLabel2.setText("max. Gewicht");
    OKBtn.setText("Was soll ich mitnehmen?");
    OKBtn.addActionListener(new Dialog_Knapsack_OKBtn_actionAdapter(this));
    EndeBtn.setEnabled(true);
    EndeBtn.setAlignmentX( (float) 0.0);
    EndeBtn.setDebugGraphicsOptions(0);
    EndeBtn.setActionCommand("Muss jetzt Rucksack packen :)");
    EndeBtn.setContentAreaFilled(true);
    EndeBtn.setText("Gehe auf Reisen - adieu!");
    EndeBtn.addActionListener(new Dialog_Knapsack_EndeBtn_actionAdapter(this));
    textfeld.setText("");
    xYLayout1.setWidth(536);
    xYLayout1.setHeight(125+maxanz*16);
    jT.setFont(new java.awt.Font("Dialog", 0, 10));
    jT.setBorder(BorderFactory.createRaisedBevelBorder());
    jScrollPane1.setEnabled(true);
    jScrollPane1.setForeground(Color.black);
    jScrollPane1.setBorder(titledBorder2);
    jScrollPane1.setDebugGraphicsOptions(0);
    this.getContentPane().add(panel1, new XYConstraints(75, 49, -1, -1));
    this.getContentPane().add(textfeld, new XYConstraints(114, 9, 184, 26));
    this.getContentPane().add(jScrollPane1, new XYConstraints(3, 42, 530, 45+maxanz*16));
    this.getContentPane().add(EndeBtn, new XYConstraints(174, 95+maxanz*16, -1, -1));
    this.getContentPane().add(OKBtn, new XYConstraints(326, 9, -1, -1));
    this.getContentPane().add(jLabel2, new XYConstraints(12, 13, 89, -1));
    jScrollPane1.getViewport().add(jT, null);

    jT.setCellSelectionEnabled(true);
    for(int i=0;i<maxanz;i++){
      jT.setValueAt(" "+(i+1),i,0);
      jT.setValueAt("",i,1);
      jT.setValueAt("",i,2);
    }
  }

  void EndeBtn_actionPerformed(ActionEvent e) {
    dispose();
  }

  void OKBtn_actionPerformed(ActionEvent e1) {
    int i, anz;
    int schranke;
    String s=null;
    boolean ok;
    JOptionPane jOptPan = new JOptionPane();
    jT.clearSelection();
    for(anz=0;anz<maxanz && (Tab[anz][1]).length()>0;anz++);
    int g[]=new int[anz];
    double w[]=new double[anz];
    for(i=0;i<anz;i++)
      jT.setValueAt("",i,3);

    //##### zunchst die Tabellendaten und Schranke abgreifen ##################
    s=textfeld.getText();  //Schranke
    if(s.length()<1)
    { jOptPan.showMessageDialog(this,"Schranke eingeben!"); return; }
    try{ schranke=(new Integer(s)).intValue(); }
    catch(Exception exc){ jOptPan.showMessageDialog(this,
         "Schranke ist keine gltige Integer-Zahl!");  return;  }
    if(schranke<=0)
    { jOptPan.showMessageDialog(this,schranke+" als Schranke ist mir zu klein!"); return; }

    for(i=0;i<anz;i++){
      s=Tab[i][1];  //Gewichte
      if(s.length()<1){
        jOptPan.showMessageDialog(this,"Gegenstand "+(i+1)+" beschreiben!");
        jT.changeSelection(i,1,false,false);
        return;
      }
      try{ g[i]=(new Integer(s)).intValue(); }
      catch(Exception exc){
        jOptPan.showMessageDialog(this,(i+1)+" ist keine gltige Integer-Zahl!");
        jT.changeSelection(i,1,false,false);
        return;
      }
      if(g[i]<=0){
        jOptPan.showMessageDialog(this,g[i]+" ist aber ganz schn leicht!");
        jT.changeSelection(i,1,false,false);
        return;
      }
      s=Tab[i][2];  //Werte
      if(s.length()<1){
        jOptPan.showMessageDialog(this,"Gegenstand "+(i+1)+" beschreiben!");
        jT.changeSelection(i,2,false,false);
        return;
      }
      try{ w[i]=(new Double(s)).doubleValue(); }
      catch(Exception exc){
        jOptPan.showMessageDialog(this,(i+1)+" ist keine gltige Double-Zahl!");
        jT.changeSelection(i,2,false,false);
        return;
      }
      if(w[i]<=0){
        jOptPan.showMessageDialog(this,w[i]+" ist ein zu kleiner Wert!");
        jT.changeSelection(i,2,false,false);
        return;
      }
    }

    //##### jetzt Berechnung ausfhren und in Tabelle eintragen ################
    int gesGew=0; double gesWert=0;
    Knapsack ks=new Knapsack(g,w);
    int[] result=ks.getOptPackung(schranke);//in result stehen die mitzunehmenden Objekte
    for(i=0;i<result.length;i++){
      jT.setValueAt(" einpacken",result[i],3);
      gesGew+=g[result[i]];
      gesWert+=w[result[i]];
    }
    jT.setValueAt(" Summe",maxanz,0);
    jT.setValueAt("Gewicht: "+gesGew,maxanz,1);
    jT.setValueAt("Wert: "+gesWert,maxanz,2);
    jT.setValueAt("Anzahl: "+result.length,maxanz,3);
  }
}

class Dialog_Knapsack_EndeBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_Knapsack adaptee;

  Dialog_Knapsack_EndeBtn_actionAdapter(Dialog_Knapsack adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.EndeBtn_actionPerformed(e);
  }
}

class Dialog_Knapsack_OKBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_Knapsack adaptee;

  Dialog_Knapsack_OKBtn_actionAdapter(Dialog_Knapsack adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.OKBtn_actionPerformed(e);
  }
}
