package adsuebungen;

import ADS.*;
import java.util.Calendar;
import java.io.*;
import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Matthias Jauernig
 * @version 1.0
 */

public class Dialog_Such extends JDialog {
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  JButton EndeBtn = new JButton();
  JButton OKBtn = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  TitledBorder titledBorder3;
  int sanz=7;
  String[][] Tab = new String[5][sanz+1];
  String[] TabKopf = new String[] {
      " ","SortListe","SortListeKett","HashKett","HashCoal","HashDopp","AVLBaum","BBaum"};
  int dLg=1000;
  JTable jT = new JTable(Tab,TabKopf);
  JOptionPane jOptPan = new JOptionPane();

  public Dialog_Such(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public Dialog_Such() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    this.getContentPane().setLayout(xYLayout1);
    xYLayout1.setWidth(699);
    xYLayout1.setHeight(150);
    EndeBtn.setEnabled(true);
    EndeBtn.setAlignmentX( (float) 0.0);
    EndeBtn.setBorder(BorderFactory.createEtchedBorder());
    EndeBtn.setDebugGraphicsOptions(0);
    EndeBtn.setActionCommand("Beenden");
    EndeBtn.setContentAreaFilled(true);
    EndeBtn.setText("bung beenden");
    EndeBtn.addActionListener(new Dialog_Such_EndeBtn_actionAdapter(this));
    this.getContentPane().setBackground(Color.lightGray);
    OKBtn.setBorder(BorderFactory.createEtchedBorder());
    OKBtn.setActionCommand("Start");
    OKBtn.setText("Start");
    OKBtn.addActionListener(new Dialog_Such_OKBtn_actionAdapter(this));
    this.getContentPane().add(panel1, new XYConstraints(75, 49, -1, -1));
    this.getContentPane().add(jScrollPane1,             new XYConstraints(4, 3, 693, 107));
    jScrollPane1.getViewport().add(jT, null);
    this.getContentPane().add(EndeBtn, new XYConstraints(424, 113, 111, 33));
    this.getContentPane().add(OKBtn, new XYConstraints(163, 113, 111, 33));

    for(int i=1;i<=5;i++)
      jT.setValueAt("n="+dLg*i,i-1,0);
  }
  void EndeBtn_actionPerformed(ActionEvent e) {
    dispose();
  }

  void OKBtn_actionPerformed(ActionEvent ae) {
    int n=dLg, anzExp=1000, i, j, k; //anzExp dem Prozessor anpassen
    double start, ende;

    //########## Instanzen der SuchStruk-turen erzeugen ########################
    SuchStruk sl,slK,hk,hc,hd,ab,bb;//htte es ja lieber mit einem Array gemacht, aber nein...
    sl=new SortListe(dLg*5); //max. dLg*5 Elemente
    slK=new SortListeKett();
    hk=new HashKett();
    hc=new HashCoal();
    hd=new HashDopp();
    ab=new AVLBaum();
    bb=new BBaum(50); //Vorl.: "meist wird m=50 gewhlt"; hier also auch

    //########## SuchStruk's mit Werten 1,2,...,dLg*5 fllen ###################
    for(j=1; j<=dLg*5; j++){ //SuchStruk's mit Werten 1,2,...,dLg*5 fllen
      ElementtypI e=new ElementtypI(j);
      sl.einfuegen(e);  slK.einfuegen(e);  hk.einfuegen(e);  hc.einfuegen(e);
      hd.einfuegen(e);  ab.einfuegen(e);   bb.einfuegen(e);
    }

    //########## Suchen & Operationen ausfhren ################################
    for(i=1; i<=5; i++,n=dLg*i) { //von n=dLg bis n=5*dLg
      //jOptPan.showMessageDialog(this,"n="+n); //aktivieren fr Zwischenausgabe von Werten
      for(j=0;j<sanz;j++){
        start=Calendar.getInstance().getTime().getTime();
        for(k=0;k<anzExp;k++){
          ElementtypI y=null, x=new ElementtypI((int)Math.floor(Math.random()*n+1));
          switch(j){
            case 0: y=(ElementtypI)sl.suchen(x.getSchluessel());  break;
            case 1: y=(ElementtypI)slK.suchen(x.getSchluessel()); break;
            case 2: y=(ElementtypI)hk.suchen(x.getSchluessel());  break;
            case 3: y=(ElementtypI)hc.suchen(x.getSchluessel());  break;
            case 4: y=(ElementtypI)hd.suchen(x.getSchluessel());  break;
            case 5: y=(ElementtypI)ab.suchen(x.getSchluessel());  break;
            case 6: y=(ElementtypI)bb.suchen(x.getSchluessel());  break;
            default: jOptPan.showMessageDialog(this,"Algorithmus nicht vorhanden!");
          }
          if(y==null){//HashKett funktioniert z.Zt. nicht ganz, daher ausschlieen
            jOptPan.showMessageDialog(this,TabKopf[j+1]+".suchen(s) hat null zurck"+
                                      " gegeben. Darf nicht sein! => Abbruch...");
            jOptPan.showMessageDialog(this,"Suchverf="+TabKopf[j+1]+", k="+k+", n="+n+", x="+x.getSchluessel());
            return;
          }
          else{
            switch(j){
              case 0: sl.entfernen(x.getSchluessel());  sl.einfuegen(y);  break;
              case 1: slK.entfernen(x.getSchluessel()); slK.einfuegen(y); break;
              case 2: hk.entfernen(x.getSchluessel());  hk.einfuegen(y);  break;
              case 3: hc.entfernen(x.getSchluessel());  hc.einfuegen(y);  break;
              case 4: hd.entfernen(x.getSchluessel());  hd.einfuegen(y);  break;
              case 5: ab.entfernen(x.getSchluessel());  ab.einfuegen(y);  break;
              case 6: bb.entfernen(x.getSchluessel());  bb.einfuegen(y);  break;
              default: jOptPan.showMessageDialog(this,"Algorithmus nicht vorhanden!");
            }
          }
        }
        ende=Calendar.getInstance().getTime().getTime();
        jT.setValueAt((ende-start)/1000+" Sek.",i-1,j+1);
      }
    }
  }
}


class Dialog_Such_EndeBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_Such adaptee;

  Dialog_Such_EndeBtn_actionAdapter(Dialog_Such adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.EndeBtn_actionPerformed(e);
  }
}

class Dialog_Such_OKBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_Such adaptee;

  Dialog_Such_OKBtn_actionAdapter(Dialog_Such adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.OKBtn_actionPerformed(e);
  }
}
