package ADS;

import javax.swing.*;

public class HashDopp extends Hashing implements SuchStruk {

  public HashDopp() { super();
    for (int i=0; i<maxAnz; i++) Speicher[i]=new DoppItem();
  }

  public HashDopp(int dimension) {  super(dimension);
    for (int i=0; i<maxAnz; i++) Speicher[i]=new DoppItem();
  }

  public int Hashfkt2(String S) {
    int v=0, t=maxAnz-2;
    for (int j=0; j<Elementtyp.AnzSchlSt; j++)
      v=(v*Elementtyp.Radix+Elementtyp.ZWert(S,j)) % t;
    return v+1;
  }

  public int suchPos(String s) {
    boolean ok,Abbr; DoppItem DI;
    int i=Hashfkt(s), j=Hashfkt2(s);
    do {
      DI=(DoppItem) getElement(i);
      ok=s.equals(DI.getSchluessel());
      Abbr=(DI.zustand<0 || s.compareTo(DI.getSchluessel())<0);
      if (!(ok || Abbr)) i=(i+j) % maxAnz;
    } while (!(ok || Abbr));
    if (ok) return i; else return -(i+1);
  }

  public Elementtyp suchen(String s) {
    int SuchPos=suchPos(s);
    if (SuchPos>=0) {
      DoppItem DI=(DoppItem) getElement(SuchPos);
      return DI.Inhalt;
    }
    else return null;
  }

  public boolean einfuegen(Elementtyp e) {
    int i,j; boolean ok,Abbr=false; DoppItem DI, DIn;
    String s=e.getSchluessel();
    if (istVoll() || suchPos(s)>=0) return false;
    else {
      i=Hashfkt(s); j=Hashfkt2(s);
      do { DI=(DoppItem) getElement(i);
        ok=DI.zustand<=0; //frei oder entfernt
        if (!ok) {
          if (DI.getSchluessel().compareTo(s)>0) {
            Elementtyp en=DI.Inhalt; DI.Inhalt=e;
            e=en; s=e.getSchluessel(); j=Hashfkt2(s);
          }
          i=(i+j) % maxAnz;
        }
      } while (!ok);
      DI.Inhalt=e; DI.zustand=1; /** belegt */
      Anz++; return true;
    }
  }

  public boolean entfernen(String s) {
    int i=suchPos(s);
    if (istLeer() || i<0) return false;
    else {
      DoppItem DI=(DoppItem) getElement(i);
      DI.Inhalt=null; DI.zustand=0; Anz--;
      return true;
    }
  }

  public void Ausg(JTable T) {
    String S=new String();
    for (int i=0; i<maxAnz; i++) {
      DoppItem DI=(DoppItem) getElement(i);
      T.setValueAt(DI.getSchluessel(),0,i);
      T.setValueAt(S.valueOf(DI.zustand),1,i);
    }
  }

  final class DoppItem extends HashItem {
    protected int zustand=-1;

    public DoppItem() { super(); }

    public DoppItem(Elementtyp e) { super(e); }
  }

}