package ADS;

public class Knoten {
/** Knoten eines Graphen. In der Regel werden die Knoten als Mitglieder der
 *  Knotenliste ber ihre Nummer i, 1 <= i <= Graph.n angesprochen: Z.B.
 *  eEinBg(i) ein (erster) Bogen, dessen Endknoten i ist ("Eingangsbogen" in i)
 *  nEinBg(i,k) ein auf den Bogen mit der Nummer k folgender Bogen,
 *  dessen Endknoten i ist
 *  eAusBg(i) ein (erster) Bogen, dessen Anfangsknoten i ist ("Ausgangsbogen" aus i)
 *  nAusBg(i,k) ein auf den Bogen mit der Nummer k folgender Bogen,
 *  dessen Anfangsknoten i ist
 *  eInzBg(i) ein (erster) Bogen, der mit dem Knoten i inzidiert. Die Nummer
 *  wird negativ geliefert, wenn der Bogen Eingangsbogen bei i ist
 *  nInzBg(i,k) ein auf den Bogen mit der Nummer k folgender Bogen,
 *  der inzident mit i ist.
 *  KnName(i) gibt fr eine gltige Knotennummer, istKn(i) = true oder
 *  1 <= i <= n(), die *  String-Bezeichnung des Knotens.
 *  t(i) Potential im Knoten i.
 */
 public String name;
 int    EinBg=0, AusBg=0;
 int    StzBg=0, Marke=0;
 double t=0; double dt=0;
 Knoten(String name) { this.name=name; }
}

