package ADS;

public class PriorHeap extends Heap {
  protected boolean min=true;
  //Min-Heap ist Standard: ok=!eSohn.hatVorrangVor(ePos) fr beide Shne

  public PriorHeap(int maxAnz) {  super(maxAnz); }

  public boolean istMin() { return min;}

  public boolean istMax() { return !min; }

  public void setMax(boolean Wert) { min=!Wert; }

  public void setMin(boolean Wert) { min=Wert; }

  public void pushOpt(Elementtyp e) {
    if (!istVoll()) { Speicher[n]=e;  n++; hochziehen(n-1); }
  }

  public void add(Elementtyp e) {
    if (!istVoll()) { Speicher[n]=e; n++; }
  }

  public Elementtyp exOpt() {
    if (!istLeer()) {
      Elementtyp e=(Elementtyp) Speicher[0];
      elemTausch(0,n-1); n--; versickern(0,count()-1);
      return e;
    }
    else return null;
  }

  void hochziehen(int Pos) {
    int Vater;
    Elementtyp eVater,ePos;
    boolean OK=false;
    while (!OK && (Pos!=0)) {
      Vater=(Pos-1)/2;
      eVater=(Elementtyp) Speicher[Vater];
      ePos=(Elementtyp) Speicher[Pos];
      OK=istMin() && !ePos.hatVorrangVor(eVater) || istMax() && !eVater.hatVorrangVor(ePos);
      if (!OK) { elemTausch(Pos,Vater); Pos=Vater;
      }
    }
  }

  void versickern(int Pos, int EndPos) {
    Elementtyp eSohn,eRSohn,ePos;
    int Sohn=2*Pos+1;
    boolean OK=Sohn>EndPos;
    while (!OK) {
      eSohn=(Elementtyp) Speicher[Sohn];
      if (Sohn < EndPos)  {
        eRSohn=(Elementtyp) Speicher[Sohn+1];
        if (istMin() && eRSohn.hatVorrangVor(eSohn) || istMax() && eSohn.hatVorrangVor(eRSohn)) {
          Sohn++; eSohn=eRSohn;
        }
      }
      ePos=(Elementtyp) Speicher[Pos];
      OK=istMin() && !eSohn.hatVorrangVor(ePos) || istMax() && !ePos.hatVorrangVor(eSohn);
      if (!OK) { elemTausch(Pos,Sohn); Pos=Sohn; Sohn=2*Pos+1; OK=Sohn>EndPos; }
    }
  }

}
