package adsuebungen;

import ADS.*;
import java.util.Calendar;
import java.io.*;
import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Matthias Jauernig
 * @version 1.0
 */

public class Dialog_eNetz extends JDialog {
  JPanel panel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  XYLayout xYLayout1 = new XYLayout();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  JButton EndeBtn = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  TitledBorder titledBorder3;
  int spAnz=3, knAnz=8, bgAnz=13;
  String[][] Tab = new String[knAnz][spAnz];
  String[] TabKopf = new String[] {
      "Knotenname", "Weglnge", "erreicht ber Knoten"};
  JTable jT = new JTable(Tab,TabKopf);
  JOptionPane jOptPan = new JOptionPane();

  public Dialog_eNetz(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  public Dialog_eNetz() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    this.getContentPane().setLayout(xYLayout1);
    xYLayout1.setWidth(470);
    xYLayout1.setHeight(195);
    EndeBtn.setEnabled(true);
    EndeBtn.setAlignmentX( (float) 0.0);
    EndeBtn.setBorder(BorderFactory.createEtchedBorder());
    EndeBtn.setDebugGraphicsOptions(0);
    EndeBtn.setContentAreaFilled(true);
    EndeBtn.setText("Beenden");
    EndeBtn.addActionListener(new Dialog_eNetz_EndeBtn_actionAdapter(this));
    this.getContentPane().setBackground(Color.lightGray);
    this.getContentPane().add(panel1, new XYConstraints(75, 49, -1, -1));
    this.getContentPane().add(jScrollPane1,      new XYConstraints(4, 3, 465, 156));
    this.getContentPane().add(EndeBtn,                                    new XYConstraints(180, 161, 111, 33));
    jScrollPane1.getViewport().add(jT, null);
  }

  void zeigen(int was){
    int startKn=1;
    boolean ok;
    eNetz ntz=new eNetz(knAnz,bgAnz);

    //##### Testnetz aufbauen ##################################################
    ntz.insertBg("1","2","4");  ntz.insertBg("1","3","3");
    ntz.insertBg("2","3","-2"); ntz.insertBg("2","4","2");
    ntz.insertBg("4","3","-5"); ntz.insertBg("3","5","4");
    ntz.insertBg("3","6","3");  ntz.insertBg("4","6","1");
    ntz.insertBg("5","6","-3"); ntz.insertBg("5","7","1");
    ntz.insertBg("6","7","3");  ntz.insertBg("6","8","7");
    ntz.insertBg("8","7","-5");
    //##### Weglnge (krzeste/lngste) ermitteln ##############################
    switch(was){
      case -1:
        if(ntz.kuerzesteWege(startKn)==false)
          jOptPan.showMessageDialog(this,
            "Es sind Kreise negativer Lnge im Graphen vorhanden!");
        break;
      case 1:
        if(ntz.laengsteWege(startKn)==false)
          jOptPan.showMessageDialog(this,
            "Es sind Kreise positiver Lnge im Graphen vorhanden!");
        break;
      default:
        jOptPan.showMessageDialog(this,
            "Falscher Aufruf von \"zeigen()\", breche ab...");
        return;
    }
    //##### Ausgabe in Tabelle #################################################
    for(int i=1;i<=ntz.n;i++){
      jT.setValueAt(ntz.KnName(i),i-1,0);
      jT.setValueAt(String.valueOf(ntz.getT(i)),i-1,1);
      jT.setValueAt(ntz.KnName(ntz.AKn(ntz.getStzBg(i))),i-1,2);
    }
    this.show();
  }

  void EndeBtn_actionPerformed(ActionEvent e) {
    dispose();
  }
}


class Dialog_eNetz_EndeBtn_actionAdapter implements java.awt.event.ActionListener {
  Dialog_eNetz adaptee;

  Dialog_eNetz_EndeBtn_actionAdapter(Dialog_eNetz adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.EndeBtn_actionPerformed(e);
  }
}
